# I3DExShaderTransform Struct Reference
[External Interfaces]

Inheritance diagram for I3DExShaderTransform:

List of all members.

## Public Member Functions
virtual void MCCOMAPI | TransformShading (ShadingIn &result, const ShadingIn &shadingIn)=0
virtual boolean MCCOMAPI | IsEnabled ()=0
virtual void MCCOMAPI | SetEnabled (boolean enabled)=0
virtual void MCCOMAPI | SetTransform (const TTreeTransform &transform, const real32 uniformScale=1.0f)=0
virtual void MCCOMAPI | InverseTransformNormal (TVector3 &normal)=0

## Detailed Description

This is the interface for the shader transforms.

## Member Function Documentation

virtual void MCCOMAPI I3DExShaderTransform::InverseTransformNormal | ( | TVector3 & | normal | ) | `[pure virtual]`

Applies the inverse of the transform to the given normal

Parameters:

  | normal | The normal to be inverse transformed.

virtual boolean MCCOMAPI I3DExShaderTransform::IsEnabled | ( |  | ) | `[pure virtual]`

Returns true if the shading transform is set to enabled.

virtual void MCCOMAPI I3DExShaderTransform::SetEnabled | ( | boolean | enabled | ) | `[pure virtual]`

Sets the enabled status of the transform.

virtual void MCCOMAPI I3DExShaderTransform::SetTransform | ( | const TTreeTransform & | transform,
|  | const real32 | uniformScale = `1.0f` |
| ) |  |  | `[pure virtual]`

Sets the transform for the shader.

Parameters:

  | transform | A TTreeTransform from whose data the ShaderTransform parameters will be set.
  | uniformScale | An extra uniform scaling.

Returns:
  Nothing

virtual void MCCOMAPI I3DExShaderTransform::TransformShading | ( | ShadingIn & | result,
|  | const ShadingIn & | shadingIn |
| ) |  |  | `[pure virtual]`

TransformShading applies the shading transform by transforming the hit location and normals (and their derivatives) in local coordinates.

Parameters:

  | shadingIn | The original shading data
  | result | The new transformed data

The documentation for this struct was generated from the following file:

- I3DExShaderTransform.h